Code at 0000h
P2 equ 0A0h
P3 equ 0B0h
clr P3.6                           ; Eine 7-Segment-Anzeige loeschen/abschalten
init: mov DPTR, #Daten             ; Daten laden
start: clr A                       ; Akku loeschen
movC A, @A+DPTR                    ; Indirekte 16-Bit-Adressierung. 
                                   ; Es wird auf diese Weise wegen der 
                                   ; Besonderheiten des Prozessors gemacht. 
                                   ;
CJNE A, #0FFh, weiter              ; Pruefe, ob "end of line" (Ende der Zeile). 
sjmp init								  ; Wenn ja, von Anfang an.
weiter: mov P2, A                  ; Ausgabe des Akkuinhaltes
INC DPTR                           ; Naechstes Datum nehmen. 
sjmp start                         ; Zurueck zu Start 

ORG 0C0h   

Daten: DB 12h, 0BCh, 0B6h, 0D2h, 0E6h, 0EEh, 0FFh;  Liste der Zustaende der 7-Segment-Anzeige, 1 bis 6
END
