Code at 0000h

P1 equ 90h
P2 equ 0A0h
P3 equ 0B0h

clr P3.6                ; eine 7-Segment-Anzeige abschalten
mov 0F9h, #1            ; eins in die Speicherzelle 0F9h laden
init: mov DPTR, #Daten  ; s. Bemerkungen zu Nr. 4 und 5

start: clr A
       movC A, @A+DPTR
       CJNE A, #0FFh, weiter
       sjmp init
weiter: mov P2, A

stopp: JB P1.0, beschleunigen ; wenn P1.0-Schalter auf 1 steht, 
                             ;beschleunigen

langsamer:                  ;
       mov R4, 0F9h          ; der Inhalt der Speicherzelle 0F9h ins 
                             ;R4 laden
       cjne R4, #7, verzoegern ; vergleichen mit #7. 
                             ;Bei Ungleichheit zum Verzoegern (also
                             ;einfach weiter) gehen
       sjmp stopp             ; Bei Gleichheit zum Stopp gehen
verzoegern:
       inc R4                ; durch Erhoehung von R4 macht man die 
                             ; Pause laenger
       mov 0F9h, R4          ; Inhalt von R4 ins R3 ueber
       mov R3, 0F9h          ; eine Speicherzelle laden

       sjmp vor              ; Zur Pause springen
beschleunigen:
       mov R3, #1
       mov R4, 0F9h
       cjne R4, #1, go       ; wenn noch keine 1, beschleunigen  
                             ; durch go
       sjmp vor
go:
       dec R4                ; durch Verkleinerung von R4 macht man 
;                            ; die Pause kuerzer

       mov 0F9h, R4          ; Inhalt von R4 ins R3 ueber
       mov R3, 0F9h          ; eine Speicherzelle laden
vor:
       LCALL uptime         ; Pause ausfuhren 
       INC DPTR             ; naechstes Datum nehmen.
       sjmp start
Daten: DB 12h, 0BCh, 0B6h, 0D2h, 0E6h, 0EEh, 0FFh;

ORG 0C0h
uptime:
loop3: mov R2, #200
loop2: mov R1, #250
loopl: djnz R1, loopl
       djnz R2, loop2
       djnz R3, loop3
RET
END
 
