Code at 0000h

P1 equ 90h   ; Schalter
P2 equ 0A0h  ; Ausgabe
; Decoder: 
; es werden bestimmte Werte in dem 
; Adressbereich 31h bis 36h 
; abgespeichert

;------------------------
mov 31h, #08h
mov 32h, #41h
mov 33h, #49h
mov 34h, #55h
mov 35h, #5Dh
mov 36h, #77h
;------------------------
laden: mov R1, #31h   ; im R1 wird der wert
                      ; 31h abgespeichert
       mov A, @R1     ; in A steht jetzt der                       ; Wert 08h (indirekte 
                      ; Andressierung)
       mov P2, A      ; Akkuinhalt wird
                      ;ausgegeben

stopp: JB P1.0, stopp ; Stopp/Start-Schalter

count: 
inc R1                ; erhohe R1 
mov A, @R1            ; in A wird der Wert der 
                      ; Adresse, welche in R1 
                      ; steht, abgepeichert.
mov P2, A             ; Ausgabe des Akkuinhalts
cjne A, #77h, stopp   ; Verzweigen zum Stopp bei
                      ; Ungleichheit.

sjmp laden            ; Sprung zum Laden

END





